// 遊歩ロボット・ニジーク test4　(c)2014 Ryosuke Kawano

const int IR_RECEIVE = 4;
const int TEST_PIN = 10;

const char IDLE_STATE = 0;
const char HEADER_STATE = 1;
const char ON = 1;
const char OFF = 0;
const char TICK_TIME = 100;     // 刻み時間 μs
const char HEADER_DETECT_TIME = ( 1800 / TICK_TIME );

char input_level = HIGH;
char receive_state = IDLE_STATE;
char header_counter = 0;
char header_detect = OFF;

void setup( ){
  pinMode( IR_RECEIVE, INPUT_PULLUP );
  pinMode( TEST_PIN, OUTPUT );
}

void loop( ){
  input_level = digitalRead( IR_RECEIVE );
  header_check( );
  receive_data( );
  
  if ( receive_state == IDLE_STATE ){
    digitalWrite( TEST_PIN, HIGH );
  } else {
    digitalWrite( TEST_PIN, LOW );
  }
  
  delayMicroseconds( 100 );
}

void header_check( void ){
  header_counter++;
  if ( input_level == HIGH ){
    header_counter = 0;
    header_detect = OFF;
  }
  if ( header_counter >= HEADER_DETECT_TIME ){
    header_counter = HEADER_DETECT_TIME;
    header_detect = ON;
  }
}

void receive_data( void ){
  switch ( receive_state ){
  case IDLE_STATE:
    if ( header_detect == ON ){
      receive_state = HEADER_STATE;
    }
    break;
  case HEADER_STATE:
    if ( input_level == HIGH ){
      receive_state = IDLE_STATE;
    }
    break;
  }
}

