// 遊歩ロボット・ニジーク test7　(c)2014 Ryosuke Kawano

const int IR_RECEIVE = 4;
const int ID_PIN = 3;
const int TEST_PIN = 10;

const char IDLE_STATE = 0;
const char HEADER_STATE = 1;
const char GAP_STATE = 2;
const char ID_STATE = 3;
const char POST_ID_STATE = 4;
const char ON = 1;
const char OFF = 0;
const char TICK_TIME = 100;     // 刻み時間 μs
const char HEADER_DETECT_TIME = ( 1800 / TICK_TIME );
const char SHORT_BIT = ( 600 / TICK_TIME );
const char LONG_BIT = ( 1200 / TICK_TIME );
const char JUDGE_BIT = ( ( SHORT_BIT + LONG_BIT ) / 2 );

char input_level = HIGH;
char receive_state = IDLE_STATE;
char header_counter = 0;
char header_detect = OFF;
char bit_receive_counter = 0;
char id_receive = 0;
char parity_temp = 0;

void setup( ){
  pinMode( IR_RECEIVE, INPUT_PULLUP );
  pinMode( ID_PIN, INPUT_PULLUP );
  pinMode( TEST_PIN, OUTPUT );
}

void loop( ){
  input_level = digitalRead( IR_RECEIVE );
  header_check( );
  receive_data( );
  
  if ( ( receive_state == HEADER_STATE )
    || ( receive_state == GAP_STATE )
    || ( receive_state == ID_STATE ) ){
    digitalWrite( TEST_PIN, HIGH );
  } else {
    digitalWrite( TEST_PIN, LOW );
  }
  
  delayMicroseconds( 100 );
}

void header_check( void ){
  header_counter++;
  if ( input_level == HIGH ){
    header_counter = 0;
    header_detect = OFF;
  }
  if ( header_counter >= HEADER_DETECT_TIME ){
    header_counter = HEADER_DETECT_TIME;
    header_detect = ON;
  }
}

void receive_data( void ){
  switch ( receive_state ){
  case IDLE_STATE:
    if ( header_detect == ON ){
      receive_state = HEADER_STATE;
    }
    break;
  case HEADER_STATE:
    if ( input_level == HIGH ){
      bit_receive_counter = 0;
      receive_state = GAP_STATE;
    }
    break;
  case GAP_STATE:
    bit_receive_counter++;
    if ( bit_receive_counter > ( SHORT_BIT + 2 ) ){
      receive_state = IDLE_STATE;
    } else {
      if ( input_level == LOW ){
        if ( bit_receive_counter < ( SHORT_BIT - 2 ) ){
          receive_state = IDLE_STATE;
        } else {
          parity_temp = 0;
          bit_receive_counter = 0;
          receive_state = ID_STATE;
        }
      }
    }
    break;
  case ID_STATE:
    bit_receive_counter++;
    if ( bit_receive_counter > ( LONG_BIT + 3 ) ){
      receive_state = IDLE_STATE;
    } else {
      if ( input_level == HIGH ){
        if ( bit_receive_counter < ( SHORT_BIT - 2 ) ){
          receive_state = IDLE_STATE;
        } else {
          id_receive = 0;
          if ( bit_receive_counter >= JUDGE_BIT ){
            id_receive = 1;
            parity_temp = !parity_temp;
          }
          if ( id_receive == !digitalRead( ID_PIN ) ){
            bit_receive_counter = 0;
            receive_state = POST_ID_STATE;
          } else {
            receive_state = IDLE_STATE;
          }
        }
      }
    }
    break;
  case POST_ID_STATE:
    receive_state = IDLE_STATE;
    break;
  }
}

